opus/urls.py
from django.conf.urls import patterns, include, url

# Uncomment the next two lines to enable the admin:
# from django.contrib import admin
# admin.autodiscover()

urlpatterns = patterns('',
    # Examples:
    # url(r'^$', 'opus2.views.home', name='home'),
    # url(r'^opus2/', include('opus2.foo.urls')),

    # Uncomment the admin/doc line below to enable admin documentation:
    # url(r'^admin/doc/', include('django.contrib.admindocs.urls')),

    # Uncomment the next line to enable the admin:
    # url(r'^admin/', include(admin.site.urls)),
    url(r'^timer/$', 'timer.views.labels'),
    url(r'^timer/events/(\d+)/$', 'timer.views.view_event'),
    url(r'^timer/events/(\d+)/delete/$', 'timer.views.delete_event'),
    url(r'^timer/label/(\d+)/events/$', 'timer.views.events'),
    url(r'^timer/labels/$', 'timer.views.labels'),
    url(r'^timer/labels/new/$', 'timer.views.edit_label'),

    url(r'^alarm/$', 'timer.views.alarm'),

    url(r'^notes/$', 'notes.views.index'),
    url(r'^notes/tag/(\d+)/$', 'notes.views.index'),

    url(r'^notes/(\d+)/$', 'notes.views.view'),
    url(r'^notes/new/$', 'notes.views.edit'),
    url(r'^notes/(\d+)/edit/$', 'notes.views.edit'),
    url(r'^notes/(\d+)/file/(\d+)/$', 'notes.views.view_file'),
)

notes/models.py
import re
from datetime import datetime
from django.db import models
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver

class Tag(models.Model):
    title = models.CharField(max_length=128)

    class Meta:
        ordering = ['title']

class Note(models.Model):
    user = models.ForeignKey(User)
    shared = models.BooleanField(default=True)
    title = models.CharField(max_length=140, null=True, default=u'New Note')
    tags = models.ManyToManyField(Tag, null=True, blank=True)

    def get_date(self):
        return self.version_set.all()[0].created_at

    def get_user(self):
        pass

    def content(self):
        try:
            return self.version_set.latest().content
        except Version.DoesNotExist:
            return ''

    def updated_at(self):
        return self.version_set.latest().created_at

    def get_absolute_url(self):
        return '/notes/%d/' % self.pk

    class Meta:
        ordering = ['-id']

class Version(models.Model):
    note = models.ForeignKey(Note)
    user = models.ForeignKey(User)
    content = models.TextField()
    created_at = models.DateTimeField(default=datetime.now())

    class Meta:
        get_latest_by = 'created_at'

class Attachment(models.Model):
    content = models.FileField(upload_to='uploads')
    note = models.ForeignKey(Note)

    def get_name(self):
        import os.path
        return os.path.basename(self.content.name)

@receiver(post_save, sender=Version)
def version_saved(sender, instance, created, **kwargs):
    tags = re.findall('#(\w+)', instance.content)
    for t in tags:
        tag = Tag.objects.get_or_create(title=t)[0]
        instance.note.tags.add(tag)

    instance.note.save()

notes/views.py
import mimetypes
from django import forms
from django.http import HttpResponse
from django.shortcuts import render, redirect
from notes.models import Note, Attachment, Tag, Version

class NoteForm(forms.Form):
    title = forms.CharField()
    content = forms.CharField(widget=forms.Textarea(attrs={'rows': 20, 
        'style': 'width:100%;height:100%'}))
    shared = forms.BooleanField()
    attachment = forms.FileField(required=False)

def edit(request, note_id=None):

    note = Note(user_id=1)
    
    if note_id:
        note = Note.objects.get(pk=note_id)

    if request.method == 'POST':
        form = NoteForm(request.POST, request.FILES)

        if not form.is_valid():
            return render(request, 'edit.html', {'form': form, 'note': note})

        note.title = form.cleaned_data.get('title')
        note.save()

        if request.FILES.get('attachment'):
            a = Attachment(note=note)
            a.content = request.FILES['attachment']
            a.save()

        version = Version(note=note, user_id=1)
        version.content = form.cleaned_data.get('content')
        version.shared = form.cleaned_data.get('shared')
        version.save()

        return redirect(note)

    form = NoteForm(initial={
        'content': note.content, 
        'shared': note.shared, 
        'title': note.title
        })

    return render(request, 'edit.html', {'form': form, 'note': note})

def index(request, tag_id=None):
    notes = Note.objects.filter(user_id=1)

    if tag_id:
        notes = notes.filter(tags__pk=tag_id)

    tags = Tag.objects.distinct()
    return render(request, 'index.html', {'notes': notes, 'tags': tags})

def view(request, note_id):
    note = Note.objects.get(pk=note_id)
    version = note.version_set.latest()
    return render(request, 'view.html', {'note': note, 'version': version})

def view_file(request, note_id, file_id):
    note = Note.objects.get(pk=note_id)
    f = note.attachment_set.get(pk=file_id)

    mimetypes.init()
    t, e = mimetypes.guess_type(f.content.name)

    return HttpResponse(f.content.read(), content_type=t)

def delete_file(request, note_id, file_id):
    note = Note.objects.get(pk=note_id)
    f = Attachment.objects.get(pk=file_id)
    f.delete()
    return HttpResponse('File deleted')

notes/templates/edit.html
{% extends request.is_ajax|yesno:"blank.html,index.html" %}

{% block content %}
<div data-role="page">
    <div data-role="header">
        <a href="/notes/" data-icon="arrow-l" data-ajax="false">Notes</a>
        <h1>{{ note.title }}</h1>
        <a href="#" id="done">Done</a>
    </div>
    <div data-role="content">
        <form action="" method="post" id="noteForm" enctype="multipart/form-data" data-ajax="false">
            {% csrf_token %}
            {{ form }}
            <ul data-role="listview" data-inset="true">
            {% for a in note.attachment_set.all %}
                <li><a href="/notes/{{ note.id }}/files/{{ a.id }}/delete/">{{ a.get_name }}</a></li>
            {% endfor %}
            </ul>
            <button type="submit" data-theme="b">Save</button>
            {% if form.is_bound %}
                <a href="delete/" data-role="button">Delete</a>
            {% endif %}
        </form>
    </div>
</div>

<script type="text/javascript">
    $(function(){
        $('#id_title').focus();
    });
    $('#done').click(function(e){
        e.preventDefault();
        $('#noteForm').submit();
    });
</script>
{% endblock content %}

notes/templates/index.html
{% extends request.is_ajax|yesno:"blank.html,default.html" %}

{% block content %}
<div data-role="page">
    <div data-role="header" data-position="fixed">
        <a href="#tagPopup" data-icon="gear" data-rel="popup">Tags</a>
        <h1>Notes</h1>
        <a href="/notes/new/" class="ui-btn-right">New</a>
    </div>
    <div data-role="content">
        <ul data-role="listview" data-filter="true">
        {% for n in notes %}
            <li><a href="{{ n.get_absolute_url }}">{{ n.title }}<p class="ui-li-aside ui-li-desc">{{ n.user.username }} @ {{ n.updated_at|date:"SHORT_DATE_FORMAT" }}</p></a></li>
        {% endfor %}
        </ul>

        <div data-role="popup" id="tagPopup">
            <ul data-role="listview" data-inset="true">
            {% for t in tags %}
                <li><a href="/notes/tag/{{ t.pk }}/">{{ t.title }} <span class="ui-li-count">{{ t.note_set.count }}</span></a></li>
            {% endfor %}
            </ul>
        </div>
    </div>
</div>

{% endblock content %}

notes/templates/view.html
{% extends request.is_ajax|yesno:"blank.html,index.html" %}
{% load markup %}

{% block content %}
<div data-role="page">
    <div data-role="header">
        <a href="/notes/" data-icon="arrow-l">Notes</a>
        <h1>{{ note.title }}</h1>
        <a href="{{ note.get_absolute_url }}edit/" data-ajax="false">Edit</a>
    </div>
    <div data-role="content">   
        <p>{{ version.content|restructuredtext }}</p>
        <ul data-role="listview" data-inset="true">
        {% for a in note.attachment_set.all %}
            <li><a href="/notes/{{ note.id }}/file/{{ a.id }}/">{{ a.get_name }}<span class="ui-li-aside ui-li-desc">{{ a.content.size|filesizeformat }}</span></a></li>
        {% endfor %}
        </ul>
    </div>
    <div data-role="footer" class="ui-bar" data-position="fixed" data-theme="b">
        <a href="delete" data-icon="delete" data-role="button">Delete</a>
    </div>
</div>
{% endblock content %}